"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const nest_swagger_checker_1 = require("nest-swagger-checker");
const now = () => Date.now() / 1000;
// * State
let ERRORS = {};
let FIRST_RUN = true;
// * SwaggerAnalyzer stuff
const swaggerAnalyzer = new nest_swagger_checker_1.SwaggerAnalyzer({
    interactive: false,
});
ERRORS = swaggerAnalyzer.run();
// HACK: ...
setTimeout(() => {
    FIRST_RUN = false;
}, 5000);
const getErrors = (overwrittenFiles) => {
    if (FIRST_RUN) {
        return ERRORS;
    }
    return swaggerAnalyzer.run({ overwrittenFiles });
};
const apiParamRule = {
    defaultOptions: [],
    meta: {
        type: 'problem',
        messages: {
            swaggerError: "{{errorMessage}}"
        },
        docs: {
            description: 'Rule to check whether param of endpoint has correct information\'s in ApiParam decorator',
            url: 'https://github.com/ozkersemih/nest-swagger-checker/blob/master/README.md'
        },
        schema: [], // no options
    },
    create: function (context) {
        return {
            ClassDeclaration() {
                var _a;
                (_a = getErrors([[context.filename, context.sourceCode.text]])[context.filename]) === null || _a === void 0 ? void 0 : _a.forEach((error) => {
                    if (error.kind === nest_swagger_checker_1.ErrorKind.ApiParamError) {
                        context.report({
                            messageId: 'swaggerError',
                            data: {
                                errorMessage: error.description
                            },
                            loc: {
                                column: error.col,
                                line: error.line,
                            }
                        });
                    }
                });
            }
        };
    },
};
exports.default = apiParamRule;
